<?php
/**
 * Created by JetBrains PhpStorm.
 * User: gustavoavila
 * Date: 23/10/12
 * Time: 09:58
 * To change this template use File | Settings | File Templates.
 */

class FctLogic
{
    protected $_entity;
    protected $_stored = array();
    private $storage;

    public function __construct(TkEntity $entity = null)
    {
        if(isset($entity)) {
            $this->_entity = $entity;
        }
    }

    public function storedInSession($storedVars, $context)
    {
        $storedInSession = array();
        foreach ($storedVars as $svar) {
            try {
                $storedInSession[$svar] = tk_get_context_vars($svar, $context);
            } catch(Exception $e) {
                continue;
            }
        }
        $this->setStoredInSession($storedInSession);
    }

    public function getEntity()
    {
        return $this->_entity;
    }

    public function setStoredInSession($values)
    {
        $this->_stored["session"] = $values;
    }

    public function getValueFromSession($var)
    {
        return isset($this->_stored["session"][$var]) ? $this->_stored["session"][$var] : null;
    }

    /**
    * Magic method call
    *
    * @param string $name Func name.
    * @param array  $args Func parameters.
    *
    * @return mixed
    */
   public function __call($name, array $args){
       switch($name) {
           case (substr($name, 0, 3) === 'get'):
               if(method_exists($this->_entity, $name)) {
                   return $this->_entity->$name();
               } else {
                   $idx = strtolower(substr($name, 3, strlen($name)));
                   if(isset($this->storage[$idx])) return $this->storage[$idx];
               }
               break;
           case (substr($name, 0, 3) === 'set'):
               if(method_exists($this->_entity, $name)) {
                   $this->_entity->$name($args[0]);
               } else {
                   $idx = strtolower(substr($name, 3, strlen($name)));
                   $this->storage[$idx] = $args[0];
               }

               break;
           default:
               break;
           }
   }

    public function persistValues()
    {
        if($this->_entity instanceof TkEntity) {
            try{
                $this->getEntity()->persist();
            } catch(Exception $e) {
                throw $e;
            }
        }
    }
}
