CREATE OR REPLACE PROCEDURE ARQUIVO_GMB(
   P_CDEMPRESA    IN  EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN  INSCRESTAD.CDINSCESTA%TYPE,
   P_DTINICIAL    IN  NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN  NOTAFISCAL.DTENTRSAID%TYPE,
   P_CDIMPOSTO    IN  IMPOSTONF.CDIMPOSTO%TYPE,
   P_CDLIVROMAG   IN  LIVROMAGNETICO.CDLIVROMAG%TYPE,
   P_NRSEQARQMAG  IN  NOTAFISCAL.NRLANCTONF%TYPE,
   P_CATEGORIA    IN  NOTAFISCAL.IDENTRSAIDOP%TYPE,
   P_ATODECL      IN  NOTAFISCAL.NRLANCTONF%TYPE)
IS
   V_NRINSJUREMPR   VARCHAR2(14);
   V_NMRAZSOCEMPR   VARCHAR2(46);
   V_CDINSCESTA     VARCHAR2(16);
   V_VRESTOQUE      NUMBER;
   V_VRTOTESTOQUE   NUMBER;
   V_NMMUNICIPIO    VARCHAR2(25);
   V_NMCONTADOR     VARCHAR2(46);
   V_NRTELCONTATO   VARCHAR2(46);
   V_NRINSJURCONT   VARCHAR2(46);
   V_NRCRCCONT2     VARCHAR2(46);
   V_DSENDINTERN    VARCHAR2(46);
   V_DTULTATUMUNI   VARCHAR2(08);
   V_001            VARCHAR2(4000);
   V_910            VARCHAR2(4000);
   V_920            VARCHAR2(4000);
   V_920_CUSTOS     NUMBER;
   V_DADOS_920      VARCHAR2(4000);
   V_CONT_MUNI      NUMBER;
   V_930            VARCHAR2(4000);
   V_940            VARCHAR2(4000);
   V_941            VARCHAR2(4000);
   V_DADOS_941      VARCHAR2(4000);
   V_CONT_UF_E      NUMBER;
   V_942            VARCHAR2(4000);
   V_DADOS_942      VARCHAR2(4000);
   V_CONT_UF_S      NUMBER;
   V_950            VARCHAR2(4000);
   V_DADOS_950      VARCHAR2(4000);
   V_CONT_CFOP      NUMBER;
   V_960            VARCHAR2(4000);
   V_DADOS_960      VARCHAR2(4000);
   V_CONT_PAIS      NUMBER;
   V_970            VARCHAR2(4000);
   V_990            VARCHAR2(4000);

BEGIN
   BEGIN
      SELECT NVL(I.CDINSCESTA,'0'), NVL(I.NRINSJURIEST,'0'), NVL(E.NMRAZSOCEMPR,' '),
             NVL(M.NMMUNICIPIO,' '), TO_CHAR(M.DTULTATUMUNI, 'yyyymmdd'),
             NVL(C.NMCONTADOR,' '), NVL(C.NRTELCONTATO,'0'), NVL(C.NRINSJURCONT,'0'), NVL(C.NRCRCCONT2,' '), NVL(C.DSENDINTERN,' ')
        INTO V_CDINSCESTA, V_NRINSJUREMPR, V_NMRAZSOCEMPR,
             V_NMMUNICIPIO, V_DTULTATUMUNI,
             V_NMCONTADOR, V_NRTELCONTATO, V_NRINSJURCONT, V_NRCRCCONT2, V_DSENDINTERN
        FROM EMPRESA E, INSCRESTAD I, MUNICIPIO M, CONTADOR C
       WHERE E.CDEMPRESA   = I.CDEMPRESA
         AND I.CDEMPRESA   = P_CDEMPRESA
         AND I.CDINSCESTA  = P_CDINSCESTA
         AND I.CDPAIS      = M.CDPAIS
         AND I.SGESTADO    = M.SGESTADO
         AND I.CDMUNICIPIO = M.CDMUNICIPIO
         AND I.CDCONTADOR2 = C.CDCONTADOR2(+);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
        V_NRINSJUREMPR := NULL;
        V_NMRAZSOCEMPR := NULL;
        V_CDINSCESTA   := NULL;
        V_NMMUNICIPIO  := NULL;
        V_DTULTATUMUNI := NULL;
   END;

   FOR C_FILIAL IN (SELECT CDFILIAL
                      FROM FILIAL
                     WHERE CDEMPRESA = P_CDEMPRESA
                       AND CDINSCESTA = P_CDINSCESTA) LOOP

      IF C_FILIAL.CDFILIAL IS NOT NULL THEN
         SELECT SUM(ROUND(VRESTOQDIA,2))
           INTO V_VRESTOQUE
           FROM POSESTDIA B
          WHERE B.CDFILIAL   = C_FILIAL.CDFILIAL
            AND B.QTESTOQDIA <> 0
            AND B.DTPOSIESTQ = (SELECT MAX(P.DTPOSIESTQ)
                                  FROM POSESTDIA P
                                 WHERE P.CDFILIAL   = C_FILIAL.CDFILIAL
                                   AND P.CDPRODUTO  = B.CDPRODUTO
                                   AND P.NRLOTEESTQ = B.NRLOTEESTQ
                                   AND P.NRSUBLOTE  = B.NRSUBLOTE
                                   AND P.DTPOSIESTQ <= P_DTINICIAL);

         V_VRTOTESTOQUE := NVL(V_VRTOTESTOQUE,0)+NVL(V_VRESTOQUE,0);
      ELSE
         V_VRTOTESTOQUE := NVL(V_VRTOTESTOQUE,0)+0;
      END IF;
   END LOOP;

   V_001 := '001'||
            LPAD(V_CDINSCESTA,10,'0')|| --CGC
            LPAD(V_NRINSJUREMPR,14,'0')|| --CNPJ
            RPAD(V_NMRAZSOCEMPR,46,' ')|| --RAZAO SOCIAL
            TO_CHAR(P_DTINICIAL, 'yyyymmdd')|| --INICIAL
            TO_CHAR(P_DTFINAL, 'yyyymmdd')||   --FINAL
            P_CATEGORIA||  --CATEGORIA
            '0000000000000000'|| /* faturamento */
            '00000'||  --EMPREGADO
            '0000000000000000'||  --VALOR DA FOLHA
            '000000000000'||   --KWH
            '0000000000000000000000000000'||  --RESERVADO
            LTRIM(REPLACE(TO_CHAR(NVL(V_VRESTOQUE,'0'), '000000000000.00'),'.',''))|| --PROPRIA TRIBUTADO NO  ESTABELECIMENTO
            '00000000000000'||  --REFERENCIA 14
            '00000000000000'||  --REFERENCIA 16
            '00000000000000'||  --REFERENCIA 17
            '00000000000000'||  --REFERENCIA 19
            '00000000000000'||  --REFERENCIA 20
            '00000000000000'||  --REFERENCIA 22
            '00000000000000'||  --REFERENCIA 23
            RPAD(NVL(V_NMMUNICIPIO, ' '), 25, ' ')|| --LOCAL RECIBO
            LPAD(NVL(V_DTULTATUMUNI, '0'), 8, '0')|| --DATA RECIBO
            RPAD(NVL(V_NMCONTADOR, ' '), 30, ' ')||  --NOME DO ENCARREGADO
            '00'||                                   --DDD
            '00000000'||                             --FONE
            RPAD(NVL(V_NMCONTADOR, ' '), 30, ' ')|| /* nome contador */
            LPAD(NVL(SUBSTR(V_NRTELCONTATO,2,2),'0'), 2, '0')||  --DDD CONTADOR
            LPAD(NVL(SUBSTR(V_NRTELCONTATO, 6,8),'0'), 8, '0')|| --TEL CONTADOR
            RPAD(NVL(V_NRINSJURCONT,'0'), 14, '0')||  --CPF/CNPJ
            RPAD(NVL(V_NRCRCCONT2,' '), 9, ' ') ||  --CRC
            RPAD(NVL(V_DSENDINTERN,' '), 100, ' ')||
            LPAD(NVL(P_ATODECL,'0'),8,'0')||  --ATO DECLARATORIO
            '0' ||--INDICADOR DE BAIXA
            '0000000000000000'; --ZEROS

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD(RTRIM('1'), 10, '0'), V_001, P_NRSEQARQMAG);

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD(RTRIM('2'), 10, '0'), RPAD('910'||V_910,540,'0'), P_NRSEQARQMAG);

   /* 920 TRANSPORTE*/
   V_920_CUSTOS := 0;
   FOR C_MUNICIPIO IN (SELECT M.CDMUNICIPIOGMB AS CDMUNICGMB, M.CDMUNICIPIO, E.SGESTADO, P.CDPAIS
                         FROM MUNICIPIO M, ESTADO E, PAIS P
                        WHERE P.CDPAISGMB = '311'
                          AND E.CDPAIS = P.CDPAIS
                          AND E.CDESTADOGMB = '21'/*RS*/
                          AND M.CDPAIS = E.CDPAIS
                          AND M.SGESTADO = E.SGESTADO
                          AND M.CDMUNICIPIOGMB IS NOT NULL
                        ORDER BY CDMUNICIPIOGMB) LOOP

      FOR C_REG920 IN (SELECT CODMUNIC, SUM(VALOR_E) AS VALOR_E, SUM(VALOR_S) AS VALOR_S
                         FROM (SELECT C_MUNICIPIO.CDMUNICGMB AS CODMUNIC,
                                      SUM(VRCONTABILNF) AS VALOR_S,
                                      0 AS VALOR_E
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N, ENDEFILI E
                                WHERE M.CDEMPRESA = P_CDEMPRESA
                                  AND M.CDINSCESTA = P_CDINSCESTA
                                  AND M.CDIMPOSTO = P_CDIMPOSTO
                                  AND M.DTINIPERIODO >= P_DTINICIAL
                                  AND M.DTFIMPERIODO <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFISCOPERNF IN ('5351','5352','5353','5354','5355','5356','5357','5359',
                                                         '6351','6352','6353','6354','6355','6356','6357','6359')
                                  AND I.CDFILIAL = N.CDFILIAL
                                  AND I.NRLANCTONF = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP = 'S'
                                  AND N.CDFILIEMIT = E.CDFILIAL
                                  AND E.IDTPENDEFILI = 'P'
                                  AND E.CDPAIS = C_MUNICIPIO.CDPAIS
                                  AND E.SGESTADO = C_MUNICIPIO.SGESTADO
                                  AND E.CDMUNICIPIO = C_MUNICIPIO.CDMUNICIPIO
                                GROUP BY C_MUNICIPIO.CDMUNICGMB)
                         GROUP BY CODMUNIC
                         ORDER BY CODMUNIC) LOOP
         V_920_CUSTOS := NVL(V_920_CUSTOS,0) + (C_REG920.VALOR_S);
         V_DADOS_920 := LPAD(C_REG920.CODMUNIC,3,'0')||
                        LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG920.VALOR_S),'00000000000000.00'),'0'),'.',''));

         V_CONT_MUNI := NVL(V_CONT_MUNI,0) + 1;

      END LOOP;

      V_920 := NVL(V_920,'')||NVL(V_DADOS_920,'');
      V_DADOS_920 := NULL;

      IF V_CONT_MUNI = 26 THEN
         V_920 := LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(V_920_CUSTOS),'00000000000000.00'),'0'),'.',''))||V_920;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('31'), 10, '0'), RPAD('920'||P_CDINSCESTA||'1'||V_920,540,'0'), P_NRSEQARQMAG);
         V_920 := NULL;
         V_920_CUSTOS := 0;
         V_CONT_MUNI := 0;
      END IF;
   END LOOP;

   IF V_920 IS NOT NULL THEN
      V_920 := LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(V_920_CUSTOS),'00000000000000.00'),'0'),'.',''))||V_920;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('31'), 10, '0'), RPAD('920'||P_CDINSCESTA||'1'||V_920,540,'0'), P_NRSEQARQMAG);
   END IF;
   V_920 := NULL;
   V_920_CUSTOS := 0;
   V_DADOS_920 := NULL;
   V_CONT_MUNI := NULL;
   /* END 920 TRANSPORTE*/

   /* 920 ENERGIA ELETRICA - DISTRIBUICAO */
   FOR C_MUNICIPIO IN (SELECT M.CDMUNICIPIOGMB AS CDMUNICGMB, M.CDMUNICIPIO, E.SGESTADO, P.CDPAIS
                         FROM MUNICIPIO M, ESTADO E, PAIS P
                        WHERE P.CDPAISGMB = '311'
                          AND E.CDPAIS = P.CDPAIS
                          AND E.CDESTADOGMB = '21'/*RS*/
                          AND M.CDPAIS = E.CDPAIS
                          AND M.SGESTADO = E.SGESTADO
                          AND M.CDMUNICIPIOGMB IS NOT NULL
                        ORDER BY CDMUNICIPIOGMB) LOOP

      FOR C_REG920 IN (SELECT CODMUNIC, SUM(VALOR_E) AS VALOR_E, SUM(VALOR_S) AS VALOR_S
                         FROM (SELECT C_MUNICIPIO.CDMUNICGMB AS CODMUNIC,
                                      SUM(VRCONTABILNF) AS VALOR_S,
                                      0 AS VALOR_E
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N, ENDEFILI E
                                WHERE M.CDEMPRESA = P_CDEMPRESA
                                  AND M.CDINSCESTA = P_CDINSCESTA
                                  AND M.CDIMPOSTO = P_CDIMPOSTO
                                  AND M.DTINIPERIODO >= P_DTINICIAL
                                  AND M.DTFIMPERIODO <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFISCOPERNF IN ('5252','5253','5254','5255','5256','5257','5258')
                                  AND I.CDFILIAL = N.CDFILIAL
                                  AND I.NRLANCTONF = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP = 'S'
                                  AND N.CDFILIEMIT = E.CDFILIAL
                                  AND E.IDTPENDEFILI = 'P'
                                  AND E.CDPAIS = C_MUNICIPIO.CDPAIS
                                  AND E.SGESTADO = C_MUNICIPIO.SGESTADO
                                  AND E.CDMUNICIPIO = C_MUNICIPIO.CDMUNICIPIO
                                GROUP BY C_MUNICIPIO.CDMUNICGMB)
                         GROUP BY CODMUNIC
                         ORDER BY CODMUNIC) LOOP

         V_920_CUSTOS := NVL(V_920_CUSTOS,0) + (C_REG920.VALOR_S-C_REG920.VALOR_E);

         V_DADOS_920 := LPAD(C_REG920.CODMUNIC,3,'0')||
                        LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG920.VALOR_S),'00000000000000.00'),'0'),'.',''));

         V_CONT_MUNI := NVL(V_CONT_MUNI,0) + 1;

      END LOOP;

      V_920 := NVL(V_920,'')||NVL(V_DADOS_920,'');
      V_DADOS_920 := NULL;

      IF V_CONT_MUNI = 26 THEN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('32'), 10, '0'), RPAD('920'||P_CDINSCESTA||'2'||V_920_CUSTOS||V_920,540,'0'), P_NRSEQARQMAG);
         V_920 := NULL;
         V_920_CUSTOS := 0;
         V_CONT_MUNI := 0;
      END IF;
   END LOOP;

   IF V_920 IS NOT NULL THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('32'), 10, '0'), RPAD('920'||P_CDINSCESTA||'2'||V_920_CUSTOS||V_920,540,'0'), P_NRSEQARQMAG);
   END IF;
   V_920 := NULL;
   V_920_CUSTOS := 0;
   V_DADOS_920 := NULL;
   V_CONT_MUNI := NULL;
   /* END 920 ENERGIA ELETRICA - DISTRIBUICAO*/

   /* 920 COMUNICACAO */
   FOR C_MUNICIPIO IN (SELECT M.CDMUNICIPIOGMB AS CDMUNICGMB, M.CDMUNICIPIO, E.SGESTADO, P.CDPAIS
                         FROM MUNICIPIO M, ESTADO E, PAIS P
                        WHERE P.CDPAISGMB = '311'
                          AND E.CDPAIS = P.CDPAIS
                          AND E.CDESTADOGMB = '21'/*RS*/
                          AND M.CDPAIS = E.CDPAIS
                          AND M.SGESTADO = E.SGESTADO
                          AND M.CDMUNICIPIOGMB IS NOT NULL
                        ORDER BY CDMUNICIPIOGMB) LOOP

      FOR C_REG920 IN (SELECT CODMUNIC, SUM(VALOR_E) AS VALOR_E, SUM(VALOR_S) AS VALOR_S
                         FROM (SELECT C_MUNICIPIO.CDMUNICGMB AS CODMUNIC,
                                      SUM(VRCONTABILNF) AS VALOR_S,
                                      0 AS VALOR_E
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N, ENDEFILI E
                                WHERE M.CDEMPRESA = P_CDEMPRESA
                                  AND M.CDINSCESTA = P_CDINSCESTA
                                  AND M.CDIMPOSTO = P_CDIMPOSTO
                                  AND M.DTINIPERIODO >= P_DTINICIAL
                                  AND M.DTFIMPERIODO <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFISCOPERNF IN ('5301','5302','5303','5304','5305','5306','5307',
                                                         '6301','6302','6303','6304','6305','6306','6307','7301')
                                  AND I.CDFILIAL = N.CDFILIAL
                                  AND I.NRLANCTONF = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP = 'S'
                                  AND N.CDFILIEMIT = E.CDFILIAL
                                  AND E.IDTPENDEFILI = 'P'
                                  AND E.CDPAIS = C_MUNICIPIO.CDPAIS
                                  AND E.SGESTADO = C_MUNICIPIO.SGESTADO
                                  AND E.CDMUNICIPIO = C_MUNICIPIO.CDMUNICIPIO
                                GROUP BY C_MUNICIPIO.CDMUNICGMB)
                         GROUP BY CODMUNIC
                         ORDER BY CODMUNIC) LOOP

         V_920_CUSTOS := NVL(V_920_CUSTOS,0) + (C_REG920.VALOR_S-C_REG920.VALOR_E);

         V_DADOS_920 := LPAD(C_REG920.CODMUNIC,3,'0')||
                        LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG920.VALOR_S),'00000000000000.00'),'0'),'.',''));

         V_CONT_MUNI := NVL(V_CONT_MUNI,0) + 1;

      END LOOP;

      V_920 := NVL(V_920,'')||NVL(V_DADOS_920,'');
      V_DADOS_920 := NULL;

      IF V_CONT_MUNI = 26 THEN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('33'), 10, '0'), RPAD('920'||P_CDINSCESTA||'3'||V_920_CUSTOS||V_920,540,'0'), P_NRSEQARQMAG);
         V_920 := NULL;
         V_920_CUSTOS := 0;
         V_CONT_MUNI := 0;
      END IF;
   END LOOP;

   IF V_920 IS NOT NULL THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('33'), 10, '0'), RPAD('920'||P_CDINSCESTA||'3'||V_920_CUSTOS||V_920,540,'0'), P_NRSEQARQMAG);
   END IF;
   V_920 := NULL;
   V_920_CUSTOS := 0;
   V_DADOS_920 := NULL;
   V_CONT_MUNI := NULL;
   /* END 920 COMUNICACAO*/

   /* 920 AGUA */
   FOR C_MUNICIPIO IN (SELECT M.CDMUNICIPIOGMB AS CDMUNICGMB, M.CDMUNICIPIO, E.SGESTADO, P.CDPAIS
                         FROM MUNICIPIO M, ESTADO E, PAIS P
                        WHERE P.CDPAISGMB = '311'
                          AND E.CDPAIS = P.CDPAIS
                          AND E.CDESTADOGMB = '21'/*RS*/
                          AND M.CDPAIS = E.CDPAIS
                          AND M.SGESTADO = E.SGESTADO
                          AND M.CDMUNICIPIOGMB IS NOT NULL
                        ORDER BY CDMUNICIPIOGMB) LOOP

      FOR C_REG920 IN (SELECT CODMUNIC, SUM(VALOR_E) AS VALOR_E, SUM(VALOR_S) AS VALOR_S
                         FROM (SELECT C_MUNICIPIO.CDMUNICGMB AS CODMUNIC,
                                      SUM(VRCONTABILNF) AS VALOR_S,
                                      0 AS VALOR_E
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N, ENDEFILI E
                                WHERE M.CDEMPRESA = P_CDEMPRESA
                                  AND M.CDINSCESTA = P_CDINSCESTA
                                  AND M.CDIMPOSTO = P_CDIMPOSTO
                                  AND M.DTINIPERIODO >= P_DTINICIAL
                                  AND M.DTFIMPERIODO <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFISCOPERNF IN ('5101','5102')
                                  AND I.CDFILIAL = N.CDFILIAL
                                  AND I.NRLANCTONF = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP = 'S'
                                  AND N.CDMODDOCFISC = '29' /*FORNECIMENTO DE AGUA*/
                                  AND N.CDFILIEMIT = E.CDFILIAL
                                  AND E.IDTPENDEFILI = 'P'
                                  AND E.CDPAIS = C_MUNICIPIO.CDPAIS
                                  AND E.SGESTADO = C_MUNICIPIO.SGESTADO
                                  AND E.CDMUNICIPIO = C_MUNICIPIO.CDMUNICIPIO
                                GROUP BY C_MUNICIPIO.CDMUNICGMB)
                         GROUP BY CODMUNIC
                         ORDER BY CODMUNIC) LOOP

         V_920_CUSTOS := NVL(V_920_CUSTOS,0) + (C_REG920.VALOR_S-C_REG920.VALOR_E);

         V_DADOS_920 := LPAD(C_REG920.CODMUNIC,3,'0')||
                        LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG920.VALOR_S),'00000000000000.00'),'0'),'.',''));

         V_CONT_MUNI := NVL(V_CONT_MUNI,0) + 1;

      END LOOP;

      V_920 := NVL(V_920,'')||NVL(V_DADOS_920,'');
      V_DADOS_920 := NULL;

      IF V_CONT_MUNI = 26 THEN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('34'), 10, '0'), RPAD('920'||P_CDINSCESTA||'4'||V_920_CUSTOS||V_920,540,'0'), P_NRSEQARQMAG);
         V_920 := NULL;
         V_920_CUSTOS := 0;
         V_CONT_MUNI := 0;
      END IF;
   END LOOP;

   IF V_920 IS NOT NULL THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('34'), 10, '0'), RPAD('920'||P_CDINSCESTA||'4'||V_920_CUSTOS||V_920,540,'0'), P_NRSEQARQMAG);
   END IF;
   V_920 := NULL;
   V_920_CUSTOS := 0;
   V_DADOS_920 := NULL;
   V_CONT_MUNI := NULL;
   /* END 920 AGUA */

   /* 920 VENDAS FORA DO ESTABELECIMENTO */
   FOR C_MUNICIPIO IN (SELECT M.CDMUNICIPIOGMB AS CDMUNICGMB, M.CDMUNICIPIO, E.SGESTADO, P.CDPAIS
                         FROM MUNICIPIO M, ESTADO E, PAIS P
                        WHERE P.CDPAISGMB = '311'
                          AND E.CDPAIS = P.CDPAIS
                          AND E.CDESTADOGMB = '21'/*RS*/
                          AND M.CDPAIS = E.CDPAIS
                          AND M.SGESTADO = E.SGESTADO
                          AND M.CDMUNICIPIOGMB IS NOT NULL
                        ORDER BY CDMUNICIPIOGMB) LOOP

      FOR C_REG920 IN (SELECT CODMUNIC, SUM(VALOR_E) AS VALOR_E, SUM(VALOR_S) AS VALOR_S
                         FROM (SELECT C_MUNICIPIO.CDMUNICGMB AS CODMUNIC,
                                      SUM(DECODE(N.IDENTRSAIDOP,'S',VRCONTABILNF,0)) AS VALOR_S,
                                      SUM(DECODE(N.IDENTRSAIDOP,'E',VRCONTABILNF,0)) AS VALOR_E
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N, ENDEFILI E
                                WHERE M.CDEMPRESA = P_CDEMPRESA
                                  AND M.CDINSCESTA = P_CDINSCESTA
                                  AND M.CDIMPOSTO = P_CDIMPOSTO
                                  AND M.DTINIPERIODO >= P_DTINICIAL
                                  AND M.DTFIMPERIODO <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFISCOPERNF IN ('5414','5415','5904','1414','1415','1904')
                                  AND I.CDFILIAL = N.CDFILIAL
                                  AND I.NRLANCTONF = N.NRLANCTONF
                                  AND N.CDFILIEMIT = E.CDFILIAL
                                  AND E.IDTPENDEFILI = 'P'
                                  AND E.CDPAIS = C_MUNICIPIO.CDPAIS
                                  AND E.SGESTADO = C_MUNICIPIO.SGESTADO
                                  AND E.CDMUNICIPIO = C_MUNICIPIO.CDMUNICIPIO
                                GROUP BY C_MUNICIPIO.CDMUNICGMB)
                         GROUP BY CODMUNIC
                         ORDER BY CODMUNIC) LOOP

         V_920_CUSTOS := NVL(V_920_CUSTOS,0) + (C_REG920.VALOR_S-C_REG920.VALOR_E);

         V_DADOS_920 := LPAD(C_REG920.CODMUNIC,3,'0')||
                        LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG920.VALOR_S),'00000000000000.00'),'0'),'.',''));

         V_CONT_MUNI := NVL(V_CONT_MUNI,0) + 1;

      END LOOP;

      V_920 := NVL(V_920,'')||NVL(V_DADOS_920,'');
      V_DADOS_920 := NULL;

      IF V_CONT_MUNI = 26 THEN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('35'), 10, '0'), RPAD('920'||P_CDINSCESTA||'5'||V_920_CUSTOS||V_920,540,'0'), P_NRSEQARQMAG);
         V_920 := NULL;
         V_920_CUSTOS := 0;
         V_CONT_MUNI := 0;
      END IF;
   END LOOP;

   IF V_920 IS NOT NULL THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('35'), 10, '0'), RPAD('920'||P_CDINSCESTA||'5'||V_920_CUSTOS||V_920,540,'0'), P_NRSEQARQMAG);
   END IF;
   V_920 := NULL;
   V_920_CUSTOS := 0;
   V_DADOS_920 := NULL;
   V_CONT_MUNI := NULL;
   /* END 920 VENDAS FORA DO ESTABELECIMENTO */

   /* 920 ENERGIA ELETRICA - GERACAO */
   FOR C_MUNICIPIO IN (SELECT M.CDMUNICIPIOGMB AS CDMUNICGMB, M.CDMUNICIPIO, E.SGESTADO, P.CDPAIS
                         FROM MUNICIPIO M, ESTADO E, PAIS P
                        WHERE P.CDPAISGMB = '311'
                          AND E.CDPAIS = P.CDPAIS
                          AND E.CDESTADOGMB = '21'/*RS*/
                          AND M.CDPAIS = E.CDPAIS
                          AND M.SGESTADO = E.SGESTADO
                          AND M.CDMUNICIPIOGMB IS NOT NULL
                        ORDER BY CDMUNICIPIOGMB) LOOP

      FOR C_REG920 IN (SELECT CODMUNIC, SUM(VALOR_E) AS VALOR_E, SUM(VALOR_S) AS VALOR_S
                         FROM (SELECT C_MUNICIPIO.CDMUNICGMB AS CODMUNIC,
                                      SUM(VRCONTABILNF) AS VALOR_S,
                                      0 AS VALOR_E
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N, ENDEFILI E
                                WHERE M.CDEMPRESA = P_CDEMPRESA
                                  AND M.CDINSCESTA = P_CDINSCESTA
                                  AND M.CDIMPOSTO = P_CDIMPOSTO
                                  AND M.DTINIPERIODO >= P_DTINICIAL
                                  AND M.DTFIMPERIODO <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFISCOPERNF IN ('5251','6251','7251')
                                  AND I.CDFILIAL = N.CDFILIAL
                                  AND I.NRLANCTONF = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP = 'S'
                                  AND N.CDFILIEMIT = E.CDFILIAL
                                  AND E.IDTPENDEFILI = 'P'
                                  AND E.CDPAIS = C_MUNICIPIO.CDPAIS
                                  AND E.SGESTADO = C_MUNICIPIO.SGESTADO
                                  AND E.CDMUNICIPIO = C_MUNICIPIO.CDMUNICIPIO
                                GROUP BY C_MUNICIPIO.CDMUNICGMB)
                         GROUP BY CODMUNIC
                         ORDER BY CODMUNIC) LOOP

         V_920_CUSTOS := NVL(V_920_CUSTOS,0) + (C_REG920.VALOR_S-C_REG920.VALOR_E);

         V_DADOS_920 := LPAD(C_REG920.CODMUNIC,3,'0')||
                        LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG920.VALOR_S),'00000000000000.00'),'0'),'.',''));

         V_CONT_MUNI := NVL(V_CONT_MUNI,0) + 1;

      END LOOP;

      V_920 := NVL(V_920,'')||NVL(V_DADOS_920,'');
      V_DADOS_920 := NULL;

      IF V_CONT_MUNI = 26 THEN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('36'), 10, '0'), RPAD('920'||P_CDINSCESTA||'6'||V_920_CUSTOS||V_920,540,'0'), P_NRSEQARQMAG);
         V_920 := NULL;
         V_920_CUSTOS := 0;
         V_CONT_MUNI := 0;
      END IF;
   END LOOP;

   IF V_920 IS NOT NULL THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('36'), 10, '0'), RPAD('920'||P_CDINSCESTA||'6'||V_920_CUSTOS||V_920,540,'0'), P_NRSEQARQMAG);
   END IF;
   V_920 := NULL;
   V_920_CUSTOS := 0;
   V_DADOS_920 := NULL;
   V_CONT_MUNI := NULL;
   /* END 920 ENERGIA ELETRICA - GERACAO */

   /* 920 REGIME ESPECIAL */
   V_920 := '';
   FOR C_MUNICIPIO IN (SELECT M.CDMUNICIPIOGMB AS CDMUNICGMB, M.CDMUNICIPIO, E.SGESTADO, P.CDPAIS
                         FROM MUNICIPIO M, ESTADO E, PAIS P
                        WHERE P.CDPAISGMB = '311'
                          AND E.CDPAIS = P.CDPAIS
                          AND E.CDESTADOGMB = '21'/*RS*/
                          AND M.CDPAIS = E.CDPAIS
                          AND M.SGESTADO = E.SGESTADO
                          AND M.CDMUNICIPIOGMB IS NOT NULL
                        ORDER BY CDMUNICIPIOGMB) LOOP

      FOR C_REG920 IN (SELECT CODMUNIC, SUM(VALOR_E) AS VALOR_E, SUM(VALOR_S) AS VALOR_S
                         FROM (SELECT C_MUNICIPIO.CDMUNICGMB AS CODMUNIC,
                                      SUM(VRCONTABILNF) AS VALOR_S,
                                      0 AS VALOR_E
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, CFOPLIVROMAG L, NOTAFISCAL N, ENDEFILI E
                                WHERE M.CDEMPRESA = P_CDEMPRESA
                                  AND M.CDINSCESTA = P_CDINSCESTA
                                  AND M.CDIMPOSTO = P_CDIMPOSTO
                                  AND M.DTINIPERIODO >= P_DTINICIAL
                                  AND M.DTFIMPERIODO <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND L.CDLIVROMAG = P_CDLIVROMAG
                                  AND L.CDLAYOUTLMAG = '001'
                                  AND I.CDFISCOPERNF = L.CDCFOPLMAG
                                  AND I.CDFILIAL = N.CDFILIAL
                                  AND I.NRLANCTONF = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP = 'S'
                                  AND N.CDFILIEMIT = E.CDFILIAL
                                  AND E.IDTPENDEFILI = 'P'
                                  AND E.CDPAIS = C_MUNICIPIO.CDPAIS
                                  AND E.SGESTADO = C_MUNICIPIO.SGESTADO
                                  AND E.CDMUNICIPIO = C_MUNICIPIO.CDMUNICIPIO
                                GROUP BY C_MUNICIPIO.CDMUNICGMB
                                UNION ALL
                                /* BUSCA O VALOR DAS NFS DE ENTRADA */
                               SELECT CDMUNICGMB,
                                      0 VALOR_S,
                                      (VRBASECALCNF + VRISENTO + VROUTRAS) - VREXCLUIDO AS VALOR_E
                                 FROM (SELECT C_MUNICIPIO.CDMUNICGMB AS CDMUNICGMB,
                                              SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                              SUM(ROUND(I.VRBASECALCNF,2)) AS VRBASECALCNF,
                                              SUM(ROUND(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0),2)) AS  VRISENTO,
                                              SUM(ROUND(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0),2)) AS  VROUTRAS,
                                              SUM(ROUND(I.VRCONTABILNF-I.VRBASECALCNF-DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0)-DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0),2)) AS VREXCLUIDO
                                         FROM MAPAAPURAC M, IMPOSTONF I, NOTAFISCAL N, IMPOSTO P, ENDEFILI E
                                        WHERE M.CDEMPRESA    = P_CDEMPRESA                   AND
                                              M.CDINSCESTA   = P_CDINSCESTA                  AND
                                              M.CDIMPOSTO    = P_CDIMPOSTO                   AND
                                              M.DTINIPERIODO >= P_DTINICIAL                  AND
                                              M.DTFIMPERIODO <= P_DTFINAL                    AND
                                              M.NRSEQUMAPAPU = I.NRSEQUMAPAPU                AND
                                              I.NRLANCTONF   = N.NRLANCTONF                  AND
                                              I.CDFILIAL     = N.CDFILIAL                    AND
                                              N.CDEMPRESA    = P_CDEMPRESA                   AND
                                              I.CDIMPOSTO    = P.CDIMPOSTO                   AND
                                              P.CDIMPOSTONFE = P_CDIMPOSTO                   AND
                                              N.CDINSCESTA   = P_CDINSCESTA                  AND
                                              N.CDFILIRECE   = E.CDFILIAL            AND
                                              N.IDENTRSAIDOP = 'E' AND
                                              NVL(IDTPENDEFILI(+),'P') = 'P' AND
                                              E.CDPAIS = C_MUNICIPIO.CDPAIS    AND
                                              E.SGESTADO = C_MUNICIPIO.SGESTADO AND
                                              E.CDMUNICIPIO = C_MUNICIPIO.CDMUNICIPIO AND
                                              I.CDFISCOPERNF IN ('1102', '1202', '1353', '1403', '2102', '2152', '2202', '2353', '2403', '2409')  AND
                                              ((I.IDIMPOSTONF <> '3') OR (I.IDIMPOSTONF IS NULL))
                                        GROUP BY C_MUNICIPIO.CDMUNICGMB ) )
                                   GROUP BY CODMUNIC
                                   ORDER BY CODMUNIC) LOOP

         V_920_CUSTOS := NVL(V_920_CUSTOS,0) + nvl(C_REG920.VALOR_E,0);
         V_DADOS_920 := LPAD(C_REG920.CODMUNIC,3,'0')||
                        LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG920.VALOR_S),'00000000000000.00'),'0'),'.',''));

         V_CONT_MUNI := NVL(V_CONT_MUNI,0) + 1;

      END LOOP;

      V_920 := NVL(V_920,'')||NVL(V_DADOS_920,'');
      V_DADOS_920 := NULL;

      IF V_CONT_MUNI = 26 THEN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('39'), 10, '0'), RPAD('920'||
                                             P_CDINSCESTA||
                                             '9'||
                                             V_920_CUSTOS||
                                             V_920,540,'0'), P_NRSEQARQMAG);
         V_920 := NULL;
         V_920_CUSTOS := 0;
         V_CONT_MUNI := 0;
      END IF;
   END LOOP;

   IF V_920 IS NOT NULL THEN

      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('39'), 10, '0'), RPAD('920'||
                                          P_CDINSCESTA||
                                          '9'||
                                          LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(V_920_CUSTOS),'00000000000000.00'),'0'),'.',''))||
                                          V_920,540,'0'), P_NRSEQARQMAG);
   END IF;
   V_920 := NULL;
   V_920_CUSTOS := 0;
   V_DADOS_920 := NULL;
   V_CONT_MUNI := NULL;
   /* END 920 REGIME ESPECIAL */

   /* 941 */
   FOR C_ESTADO IN (SELECT E.SGESTADO, E.CDESTADOGMB
                      FROM ESTADO E, PAIS P
                     WHERE P.CDPAISGMB = '311'
                       AND E.CDPAIS = P.CDPAIS
                       AND E.SGESTADO <> 'RS'
                       AND E.CDESTADOGMB IS NOT NULL
                     ORDER BY E.CDESTADOGMB) LOOP

      FOR C_REG941 IN (SELECT NF.IDENTRSAIDOP, NF.CODESTADO,
                              SUM(NF.VRCONTABIL_1) AS VRCONTABIL_1, SUM(NF.VRCONTABIL_2) AS VRCONTABIL_2,
                              SUM(NF.VRBASE_1) AS VRBASE_1, SUM(NF.VRBASE_2) AS VRBASE_2, SUM(NF.VROUTROS) AS VROUTROS,
                              SUM(NF.VRPETROLEO) AS VRPETROLEO, SUM(NF.VRPRODUTOS) AS VRPRODUTOS, SUM(VRICMS_ST) AS VRICMS_ST
                              /* ENTRADA 1 */
                         FROM (SELECT N.IDENTRSAIDOP,
                                      C_ESTADO.CDESTADOGMB AS CODESTADO,
                                      SUM(VRCONTABILNF) AS VRCONTABIL_1,
                                      0 AS VRCONTABIL_2,
                                      0 AS VRBASE_1,    --SUM(VRBASECALCNF) AS VRBASE_1,
                                      0 AS VRBASE_2,
                                      0 AS VROUTROS, --SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTROS,
                                      0 AS VRPETROLEO,
                                      0 AS VRPRODUTOS,
                                      0 AS VRICMS_ST
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N,
                                      ENDECLIE C, ENDEFORN F, ENDEFILI L, CFOPLIVROMAG C
                                WHERE M.CDEMPRESA     = P_CDEMPRESA
                                  AND M.CDINSCESTA    = P_CDINSCESTA
                                  AND M.CDIMPOSTO     = P_CDIMPOSTO
                                  AND M.DTINIPERIODO  >= P_DTINICIAL
                                  AND M.DTFIMPERIODO  <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFILIAL      = N.CDFILIAL
                                  AND I.NRLANCTONF    = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP  = 'E' ---
                                  AND N.CDCLIENTE     = C.CDCLIENTE(+)
                                  AND NVL(C.IDTPENDECLIE(+),'P') = 'P'
                                  AND N.CDFORNECED    = F.CDFORNECED(+)
                                  AND NVL(F.IDTPENDEFORN(+),'P') = 'P'
                                  AND N.CDFILIEMIT    = L.CDFILIAL(+)
                                  AND NVL(L.IDTPENDEFILI(+),'P') = 'P'
                                  and ((I.IDIMPOSTONF <> '3') OR (I.IDIMPOSTONF IS NULL))
                                  and I.CDFISCOPERNF = C.CDCFOPLMAG
                                  and C.CDLIVROMAG   = P_CDLIVROMAG
                                  and C.CDLAYOUTLMAG = '002'
                                  and substr(I.CDFISCOPERNF,1,1) = '2'
                                  AND (CASE WHEN N.IDORIGDESTNF = 'C' THEN C.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'F' THEN F.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'L' THEN L.SGESTADO END) = C_ESTADO.SGESTADO
                                GROUP BY N.IDENTRSAIDOP, C_ESTADO.CDESTADOGMB

                                UNION ALL
                                /* ENTRADA 2 */
                                SELECT N.IDENTRSAIDOP,
                                       C_ESTADO.CDESTADOGMB AS CODESTADO,
                                      SUM(VRCONTABILNF) AS VRCONTABIL_1,
                                      0 AS VRCONTABIL_2,
                                      SUM(VRBASECALCNF) AS VRBASE_1,
                                      0 AS VRBASE_2,
                                      SUM(ROUND(I.VRCONTABILNF-I.VRBASECALCNF-DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0),2)) AS VROUTROS,
                                      0 AS VRPETROLEO,
                                      0 AS VRPRODUTOS,
                                      0 AS VRICMS_ST
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N,
                                      ENDECLIE C, ENDEFORN F, ENDEFILI L, CFOPLIVROMAG C
                                WHERE M.CDEMPRESA     = P_CDEMPRESA
                                  AND M.CDINSCESTA    = P_CDINSCESTA
                                  AND M.CDIMPOSTO     = P_CDIMPOSTO
                                  AND M.DTINIPERIODO  >= P_DTINICIAL
                                  AND M.DTFIMPERIODO  <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFILIAL      = N.CDFILIAL
                                  AND I.NRLANCTONF    = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP  = 'E'
                                  AND N.CDCLIENTE     = C.CDCLIENTE(+)
                                  AND NVL(C.IDTPENDECLIE(+),'P') = 'P'
                                  AND N.CDFORNECED    = F.CDFORNECED(+)
                                  AND NVL(F.IDTPENDEFORN(+),'P') = 'P'
                                  AND N.CDFILIEMIT    = L.CDFILIAL(+)
                                  AND NVL(L.IDTPENDEFILI(+),'P') = 'P'
                                  and ((I.IDIMPOSTONF <> '3') OR (I.IDIMPOSTONF IS NULL))
                                  and I.CDFISCOPERNF = C.CDCFOPLMAG
                                  and C.CDLIVROMAG   = P_CDLIVROMAG
                                  and C.CDLAYOUTLMAG = '003'
                                  and substr(I.CDFISCOPERNF,1,1) = '2'
                                  AND (CASE WHEN N.IDORIGDESTNF = 'C' THEN C.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'F' THEN F.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'L' THEN L.SGESTADO END) = C_ESTADO.SGESTADO
                                GROUP BY N.IDENTRSAIDOP, C_ESTADO.CDESTADOGMB

                                UNION ALL
                                /* ENTRADA 3 */
                                SELECT N.IDENTRSAIDOP,
                                       C_ESTADO.CDESTADOGMB AS CODESTADO,
                                      SUM(VRCONTABILNF) AS VRCONTABIL_1,
                                      0 AS VRCONTABIL_2,
                                      SUM(VRBASECALCNF) AS VRBASE_1,
                                      0 AS VRBASE_2,
                                      SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTROS,
                                      0 AS VRPETROLEO,
                                      0 AS VRPRODUTOS,
                                      0 AS VRICMS_ST
                                  FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N,
                                      ENDECLIE C, ENDEFORN F, ENDEFILI L
                                WHERE M.CDEMPRESA     = P_CDEMPRESA
                                  AND M.CDINSCESTA    = P_CDINSCESTA
                                  AND M.CDIMPOSTO     = P_CDIMPOSTO
                                  AND M.DTINIPERIODO  >= P_DTINICIAL
                                  AND M.DTFIMPERIODO  <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFILIAL      = N.CDFILIAL
                                  AND I.NRLANCTONF    = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP  = 'E' ---
                                  AND N.CDCLIENTE     = C.CDCLIENTE(+)
                                  AND NVL(C.IDTPENDECLIE(+),'P') = 'P'
                                  AND N.CDFORNECED    = F.CDFORNECED(+)
                                  AND NVL(F.IDTPENDEFORN(+),'P') = 'P'
                                  AND N.CDFILIEMIT    = L.CDFILIAL(+)
                                  AND NVL(L.IDTPENDEFILI(+),'P') = 'P'
                                  and ((I.IDIMPOSTONF <> '3') OR (I.IDIMPOSTONF IS NULL))
                                  and I.CDFISCOPERNF NOT IN (SELECT CDCFOPLMAG
                                                         FROM CFOPLIVROMAG
                                                        WHERE CDLIVROMAG = P_CDLIVROMAG
                                                          AND CDLAYOUTLMAG = '002'
                                                       UNION ALL
                                                       SELECT CDCFOPLMAG
                                                         FROM CFOPLIVROMAG
                                                        WHERE CDLIVROMAG = P_CDLIVROMAG
                                                          AND CDLAYOUTLMAG = '003')
                                  and substr(I.CDFISCOPERNF,1,1) = '2'
                                  AND (CASE WHEN N.IDORIGDESTNF = 'C' THEN C.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'F' THEN F.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'L' THEN L.SGESTADO END) = C_ESTADO.SGESTADO
                                GROUP BY N.IDENTRSAIDOP, C_ESTADO.CDESTADOGMB

                               UNION ALL
                               /* SAIDA 1 */
                               /* o valor da base fica zerado quando o valor eh excluida */
                               SELECT N.IDENTRSAIDOP,
                                      C_ESTADO.CDESTADOGMB AS CODESTADO,
                                      SUM(VRCONTABILNF) AS VRCONTABIL_1,
                                      0 AS VRCONTABIL_2,
                                      0 AS VRBASE_1,
                                      0 AS VRBASE_2,
                                      0 AS VROUTROS, --SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTROS,
                                      0 AS VRPETROLEO,
                                      0 AS VRPRODUTOS,
                                      0 AS VRICMS_ST
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N,
                                      ENDECLIE C, ENDEFORN F, ENDEFILI L, CFOPLIVROMAG C
                                WHERE M.CDEMPRESA     = P_CDEMPRESA
                                  AND M.CDINSCESTA    = P_CDINSCESTA
                                  AND M.CDIMPOSTO     = P_CDIMPOSTO
                                  AND M.DTINIPERIODO  >= P_DTINICIAL
                                  AND M.DTFIMPERIODO  <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFILIAL      = N.CDFILIAL
                                  AND I.NRLANCTONF    = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP  = 'S'
                                  AND N.CDCLIENTE     = C.CDCLIENTE(+)
                                  AND C.IDTPENDECLIE(+) = 'P'
                                  AND N.CDFORNECED    = F.CDFORNECED(+)
                                  AND F.IDTPENDEFORN(+) = 'P'
                                  AND N.CDFILIRECE    = L.CDFILIAL(+)
                                  AND L.IDTPENDEFILI(+) = 'P'
                                  and ((I.IDIMPOSTONF <> '3') OR (I.IDIMPOSTONF IS NULL))
                                  and I.CDFISCOPERNF = C.CDCFOPLMAG
                                  and C.CDLIVROMAG   = P_CDLIVROMAG
                                  and C.CDLAYOUTLMAG = '002'
                                  AND (CASE WHEN N.IDORIGDESTNF = 'C' THEN C.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'F' THEN F.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'L' THEN L.SGESTADO END) = C_ESTADO.SGESTADO
                                  and substr(I.CDFISCOPERNF,1,1) = '6'

                                GROUP BY N.IDENTRSAIDOP, C_ESTADO.CDESTADOGMB
                              union all
                              /* SAIDA 2 */
                              SELECT N.IDENTRSAIDOP,
                                      C_ESTADO.CDESTADOGMB AS CODESTADO,
                                      SUM(VRCONTABILNF) AS VRCONTABIL_1,
                                      0 AS VRCONTABIL_2,
                                      SUM(VRBASECALCNF) AS VRBASE_1,
                                      0 AS VRBASE_2,
                                      SUM(ROUND(I.VRCONTABILNF-I.VRBASECALCNF-DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0),2)) AS VROUTROS,
                                      0 AS VRPETROLEO,
                                      0 AS VRPRODUTOS,
                                      0 AS VRICMS_ST
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N,
                                      ENDECLIE C, ENDEFORN F, ENDEFILI L, CFOPLIVROMAG C
                                WHERE M.CDEMPRESA     = P_CDEMPRESA
                                  AND M.CDINSCESTA    = P_CDINSCESTA
                                  AND M.CDIMPOSTO     = P_CDIMPOSTO
                                  AND M.DTINIPERIODO  >= P_DTINICIAL
                                  AND M.DTFIMPERIODO  <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFILIAL      = N.CDFILIAL
                                  AND I.NRLANCTONF    = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP  = 'S'
                                  AND N.CDCLIENTE     = C.CDCLIENTE(+)
                                  AND C.IDTPENDECLIE(+) = 'P'
                                  AND N.CDFORNECED    = F.CDFORNECED(+)
                                  AND F.IDTPENDEFORN(+) = 'P'
                                  AND N.CDFILIRECE    = L.CDFILIAL(+)
                                  AND L.IDTPENDEFILI(+) = 'P'
                                  and ((I.IDIMPOSTONF <> '3') OR (I.IDIMPOSTONF IS NULL))
                                  and I.CDFISCOPERNF = C.CDCFOPLMAG
                                  and C.CDLIVROMAG   = P_CDLIVROMAG
                                  and C.CDLAYOUTLMAG = '003'
                                  and substr(I.CDFISCOPERNF,1,1) = '6'
                                  AND (CASE WHEN N.IDORIGDESTNF = 'C' THEN C.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'F' THEN F.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'L' THEN L.SGESTADO END) = C_ESTADO.SGESTADO

                                GROUP BY N.IDENTRSAIDOP, C_ESTADO.CDESTADOGMB

                                union all
                              /* SAIDA 3 */
                              SELECT N.IDENTRSAIDOP,
                                      C_ESTADO.CDESTADOGMB AS CODESTADO,
                                      SUM(VRCONTABILNF) AS VRCONTABIL_1,
                                      0 AS VRCONTABIL_2,
                                      SUM(VRBASECALCNF) AS VRBASE_1,
                                      0 AS VRBASE_2,
                                      SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTROS,
                                      0 AS VRPETROLEO,
                                      0 AS VRPRODUTOS,
                                      0 AS VRICMS_ST
                                 FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM, NOTAFISCAL N,
                                      ENDECLIE C, ENDEFORN F, ENDEFILI L
                                WHERE M.CDEMPRESA     = P_CDEMPRESA
                                  AND M.CDINSCESTA    = P_CDINSCESTA
                                  AND M.CDIMPOSTO     = P_CDIMPOSTO
                                  AND M.DTINIPERIODO  >= P_DTINICIAL
                                  AND M.DTFIMPERIODO  <= P_DTFINAL
                                  AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                                  AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND I.CDFILIAL      = N.CDFILIAL
                                  AND I.NRLANCTONF    = N.NRLANCTONF
                                  AND N.IDENTRSAIDOP  = 'S'
                                  AND N.CDCLIENTE     = C.CDCLIENTE(+)
                                  AND C.IDTPENDECLIE(+) = 'P'
                                  AND N.CDFORNECED    = F.CDFORNECED(+)
                                  AND F.IDTPENDEFORN(+) = 'P'
                                  AND N.CDFILIRECE    = L.CDFILIAL(+)
                                  AND L.IDTPENDEFILI(+) = 'P'
                                  AND (CASE WHEN N.IDORIGDESTNF = 'C' THEN C.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'F' THEN F.SGESTADO
                                            WHEN N.IDORIGDESTNF = 'L' THEN L.SGESTADO END) = C_ESTADO.SGESTADO
                                  and ((I.IDIMPOSTONF <> '3') OR (I.IDIMPOSTONF IS NULL))
                                  and I.CDFISCOPERNF NOT IN (SELECT CDCFOPLMAG
                                                         FROM CFOPLIVROMAG
                                                        WHERE CDLIVROMAG = P_CDLIVROMAG
                                                          AND CDLAYOUTLMAG = '002'
                                                       UNION ALL
                                                       SELECT CDCFOPLMAG
                                                         FROM CFOPLIVROMAG
                                                        WHERE CDLIVROMAG = P_CDLIVROMAG
                                                          AND CDLAYOUTLMAG = '003')
                                  and substr(I.CDFISCOPERNF,1,1) = '6'
                                GROUP BY N.IDENTRSAIDOP, C_ESTADO.CDESTADOGMB) NF
                        GROUP BY NF.IDENTRSAIDOP, NF.CODESTADO) LOOP

         IF C_REG941.IDENTRSAIDOP = 'E' THEN
            V_DADOS_941 :=  LPAD(C_REG941.CODESTADO,2,'0')||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VRCONTABIL_1),'000000000000.00'),'0'),'.',''))||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VRBASE_1),'000000000000.00'),'0'),'.',''))||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VROUTROS),'000000000000.00'),'0'),'.',''))||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VRPETROLEO),'000000000000.00'),'0'),'.',''))||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VRPRODUTOS),'000000000000.00'),'0'),'.',''));
            V_CONT_UF_E := NVL(V_CONT_UF_E,0) + 1;
         ELSE
            V_DADOS_942 :=  LPAD(C_REG941.CODESTADO,2,'0')||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VRCONTABIL_1),'000000000000.00'),'0'),'.',''))||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VRCONTABIL_2),'000000000000.00'),'0'),'.',''))||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VRBASE_1),'000000000000.00'),'0'),'.',''))||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VRBASE_2),'000000000000.00'),'0'),'.',''))||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VROUTROS),'000000000000.00'),'0'),'.',''))||
                            LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG941.VRICMS_ST),'000000000000.00'),'0'),'.',''));
            V_CONT_UF_S := NVL(V_CONT_UF_S,0) + 1;
         END IF;

      END LOOP;

      V_941 := NVL(V_941,'')||NVL(V_DADOS_941,'');
      V_DADOS_941 := NULL;

      IF V_CONT_UF_E = 7 THEN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('41'), 10, '0'), RPAD('941'||P_CDINSCESTA||V_941,540,'0'), P_NRSEQARQMAG);
         V_941 := NULL;
         V_CONT_UF_E := 0;
      END IF;

      V_942 := NVL(V_942,'')||NVL(V_DADOS_942,'');
      V_DADOS_942 := NULL;

      IF V_CONT_UF_S = 6 THEN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('42'), 10, '0'), RPAD('942'||P_CDINSCESTA||V_942,540,'0'), P_NRSEQARQMAG);
         V_942 := NULL;
         V_CONT_UF_S := 0;
      END IF;

   END LOOP;

   IF V_941 IS NOT NULL THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('41'), 10, '0'), RPAD('941'||P_CDINSCESTA||V_941,540,'0'), P_NRSEQARQMAG);
   END IF;

   IF V_942 IS NOT NULL THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('42'), 10, '0'), RPAD('942'||P_CDINSCESTA||V_942,540,'0'), P_NRSEQARQMAG);
   END IF;

   /* 950 */
   FOR C_REG_ANEXO5 IN (/*Preencher Excludas com diferena Valor Contbil - Valores Fiscais*/
                         SELECT I.CDFISCOPERNF,
                                SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                SUM(ROUND(I.VRBASECALCNF,2)) AS VRBASECALCNF,
                                SUM(ROUND(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0),2)) AS  VRISENTO,
                                SUM(ROUND(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0),2)) AS  VROUTRAS,
                                SUM(ROUND(I.VRCONTABILNF-I.VRBASECALCNF-DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0)-DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0),2)) AS VREXCLUIDO
                           FROM MAPAAPURAC M, IMPOSTONF I, NOTAFISCAL N, IMPOSTO P
                          WHERE M.CDEMPRESA    = P_CDEMPRESA                   AND
                                M.CDINSCESTA   = P_CDINSCESTA                  AND
                                M.CDIMPOSTO    = P_CDIMPOSTO                   AND
                                M.DTINIPERIODO >= P_DTINICIAL                  AND
                                M.DTFIMPERIODO <= P_DTFINAL                    AND
                                M.NRSEQUMAPAPU = I.NRSEQUMAPAPU                AND
                                I.NRLANCTONF   = N.NRLANCTONF                  AND
                                I.CDFILIAL     = N.CDFILIAL                    AND
                                N.CDEMPRESA    = P_CDEMPRESA                   AND
                                I.CDIMPOSTO    = P.CDIMPOSTO                   AND
                                P.CDIMPOSTONFE = P_CDIMPOSTO                   AND
                                N.CDINSCESTA   = P_CDINSCESTA                  AND
                                I.CDFISCOPERNF NOT IN ('5601','5602','5605')   AND
                                I.CDFISCOPERNF NOT IN (SELECT CDCFOPLMAG
                                                         FROM CFOPLIVROMAG
                                                        WHERE CDLIVROMAG = P_CDLIVROMAG
                                                          AND CDLAYOUTLMAG = '002'
                                                       UNION ALL
                                                       SELECT CDCFOPLMAG
                                                         FROM CFOPLIVROMAG
                                                        WHERE CDLIVROMAG = P_CDLIVROMAG
                                                          AND CDLAYOUTLMAG = '003') AND
                                ((I.IDIMPOSTONF <> '3') OR (I.IDIMPOSTONF IS NULL))
                          GROUP BY I.CDFISCOPERNF
                         UNION ALL
                         /*Preencher apenas Valor Contbil e Excludas*/
                         /*Requer cadastro de cfops, tela FIS07300, em layout cdigo 002 - CFOP - EXCLUDAS VALOR INTEGRAL*/
                         SELECT I.CDFISCOPERNF,
                                SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                0 AS VRBASECALCNF,
                                0 AS VRISENTO,
                                0 AS VROUTRAS,
                                SUM(ROUND(I.VRCONTABILNF,2)) AS VREXCLUIDO
                           FROM MAPAAPURAC M, IMPOSTONF I, NOTAFISCAL N, IMPOSTO P, CFOPLIVROMAG C
                          WHERE M.CDEMPRESA    = P_CDEMPRESA                   AND
                                M.CDINSCESTA   = P_CDINSCESTA                  AND
                                M.CDIMPOSTO    = P_CDIMPOSTO                   AND
                                M.DTINIPERIODO >= P_DTINICIAL                  AND
                                M.DTFIMPERIODO <= P_DTFINAL                    AND
                                M.NRSEQUMAPAPU = I.NRSEQUMAPAPU                AND
                                I.NRLANCTONF   = N.NRLANCTONF                  AND
                                I.CDFILIAL     = N.CDFILIAL                    AND
                                N.CDEMPRESA    = P_CDEMPRESA                   AND
                                I.CDIMPOSTO    = P.CDIMPOSTO                   AND
                                P.CDIMPOSTONFE = P_CDIMPOSTO                   AND
                                N.CDINSCESTA   = P_CDINSCESTA                  AND
                                I.CDFISCOPERNF NOT IN ('5601','5602','5605')   AND
                                I.CDFISCOPERNF = C.CDCFOPLMAG                  AND
                                C.CDLIVROMAG   = P_CDLIVROMAG                  AND
                                C.CDLAYOUTLMAG = '002'                         AND
                                ((I.IDIMPOSTONF <> '3') OR (I.IDIMPOSTONF IS NULL))
                          GROUP BY I.CDFISCOPERNF
                         UNION ALL
                         /*Nao preencher Excludas - Jogar diferenca para coluna outras*/
                         /*Requer cadastro de cfops, tela FIS07300, em layout cdigo 003 - CFOP - EXCLUDAS VALOR PARCIAL*/
                         SELECT I.CDFISCOPERNF,
                                SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                SUM(ROUND(I.VRBASECALCNF,2)) AS VRBASECALCNF,
                                SUM(ROUND(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0),2)) AS  VRISENTO,
                                SUM(ROUND(I.VRCONTABILNF-I.VRBASECALCNF-DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0),2)) AS  VROUTRAS,
                                0 AS VREXCLUIDO
                           FROM MAPAAPURAC M, IMPOSTONF I, NOTAFISCAL N, IMPOSTO P, CFOPLIVROMAG C
                          WHERE M.CDEMPRESA    = P_CDEMPRESA                   AND
                                M.CDINSCESTA   = P_CDINSCESTA                  AND
                                M.CDIMPOSTO    = P_CDIMPOSTO                   AND
                                M.DTINIPERIODO >= P_DTINICIAL                  AND
                                M.DTFIMPERIODO <= P_DTFINAL                    AND
                                M.NRSEQUMAPAPU = I.NRSEQUMAPAPU                AND
                                I.NRLANCTONF   = N.NRLANCTONF                  AND
                                I.CDFILIAL     = N.CDFILIAL                    AND
                                N.CDEMPRESA    = P_CDEMPRESA                   AND
                                I.CDIMPOSTO    = P.CDIMPOSTO                   AND
                                P.CDIMPOSTONFE = P_CDIMPOSTO                   AND
                                N.CDINSCESTA   = P_CDINSCESTA                  AND
                                I.CDFISCOPERNF NOT IN ('5601','5602','5605')   AND
                                I.CDFISCOPERNF = C.CDCFOPLMAG                  AND
                                C.CDLIVROMAG   = P_CDLIVROMAG                  AND
                                C.CDLAYOUTLMAG = '003'                         AND
                                ((I.IDIMPOSTONF <> '3') OR (I.IDIMPOSTONF IS NULL))
                          GROUP BY I.CDFISCOPERNF) LOOP

      V_DADOS_950 := LPAD(C_REG_ANEXO5.CDFISCOPERNF,4,'0')||
                     LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG_ANEXO5.VRCONTABILNF),'00000000000000.00'),'0'),'.',''))||
                     LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG_ANEXO5.VRBASECALCNF),'00000000000000.00'),'0'),'.',''))||
                     LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG_ANEXO5.VRISENTO),'00000000000000.00'),'0'),'.',''))||
                     LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG_ANEXO5.VROUTRAS),'00000000000000.00'),'0'),'.',''))||
                     LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG_ANEXO5.VREXCLUIDO),'00000000000000.00'),'0'),'.',''));

      V_CONT_CFOP := NVL(V_CONT_CFOP,0) + 1;
      V_950 := NVL(V_950,'')||NVL(V_DADOS_950,'');
      V_DADOS_950 := NULL;

      IF V_CONT_CFOP = 6 THEN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('5'), 10, '0'), RPAD('950'||P_CDINSCESTA||V_950,540,'0'), P_NRSEQARQMAG);
         V_950 := NULL;
         V_CONT_CFOP := 0;
      END IF;
   END LOOP;

   IF V_950 IS NOT NULL THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('5'), 10, '0'), RPAD('950'||P_CDINSCESTA||V_950,540,'0'), P_NRSEQARQMAG);
   END IF;

   /* 960 */
   FOR C_PAIS IN (SELECT CDPAIS, CDPAISGMB
                    FROM PAIS
                   WHERE CDPAISGMB <> '311'
                     AND CDPAISGMB IS NOT NULL) LOOP

      FOR C_REG960 IN (SELECT NF.CDPAISGMB,
                              SUM(NF.VRENTRADA) AS VRENTRADA,
                              SUM(NF.VRSAIDA) AS VRSAIDA
                         FROM (SELECT C_PAIS.CDPAISGMB AS CDPAISGMB,
                                      SUM(DECODE(N.IDENTRSAIDOP,'E',VRCONTABILNF,0)) AS VRENTRADA,
                                      SUM(DECODE(N.IDENTRSAIDOP,'S',VRCONTABILNF,0)) AS VRSAIDA
                                 FROM IMPOSTONF I, NOTAFISCAL N, MAPAAPURAC M, ENDECLIE E, IMPOSTO IM
                                WHERE M.CDEMPRESA     = P_CDEMPRESA
                                  AND M.CDINSCESTA    = P_CDINSCESTA
                                  AND M.CDIMPOSTO     = P_CDIMPOSTO
                                  AND M.DTINIPERIODO  >= P_DTINICIAL
                                  AND M.DTFIMPERIODO  <= P_DTFINAL
                                  AND I.NRSEQUMAPAPU  = M.NRSEQUMAPAPU
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                  AND SUBSTR(I.CDFISCOPERNF,1,1) IN ('3','7')
                                  AND I.CDFILIAL      = N.CDFILIAL
                                  AND I.NRLANCTONF    = N.NRLANCTONF
                                  AND N.IDORIGDESTNF  = 'C'
                                  AND N.CDCLIENTE     = E.CDCLIENTE
                                  AND E.IDTPENDECLIE  = 'P'
                                  AND E.CDPAIS        = C_PAIS.CDPAIS
                                GROUP BY C_PAIS.CDPAISGMB
                               UNION ALL
                               SELECT C_PAIS.CDPAISGMB AS CDPAISGMB,
                                      SUM(DECODE(N.IDENTRSAIDOP,'E',VRCONTABILNF,0)) AS VRENTRADA,
                                      SUM(DECODE(N.IDENTRSAIDOP,'S',VRCONTABILNF,0)) AS VRSAIDA
                                 FROM IMPOSTONF I, NOTAFISCAL N, MAPAAPURAC M, ENDEFORN E, IMPOSTO IM
                                WHERE M.CDEMPRESA     = P_CDEMPRESA
                                  AND M.CDINSCESTA    = P_CDINSCESTA
                                  AND M.CDIMPOSTO     = P_CDIMPOSTO
                                  AND M.DTINIPERIODO  >= P_DTINICIAL
                                  AND M.DTFIMPERIODO  <= P_DTFINAL
                                  AND I.NRSEQUMAPAPU  = M.NRSEQUMAPAPU
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                  AND SUBSTR(I.CDFISCOPERNF,1,1) IN ('3','7')
                                  AND I.CDFILIAL      = N.CDFILIAL
                                  AND I.NRLANCTONF    = N.NRLANCTONF
                                  AND N.IDORIGDESTNF  = 'F'
                                  AND N.CDFORNECED    = E.CDFORNECED
                                  AND E.IDTPENDEFORN  = 'P'
                                  AND E.CDPAIS        = C_PAIS.CDPAIS
                                GROUP BY C_PAIS.CDPAISGMB
                               UNION ALL
                               SELECT C_PAIS.CDPAISGMB AS CDPAISGMB,
                                      SUM(DECODE(N.IDENTRSAIDOP,'E',VRCONTABILNF,0)) AS VRENTRADA,
                                      SUM(DECODE(N.IDENTRSAIDOP,'S',VRCONTABILNF,0)) AS VRSAIDA
                                 FROM IMPOSTONF I, NOTAFISCAL N, MAPAAPURAC M, ENDEFILI E, IMPOSTO IM
                                WHERE M.CDEMPRESA     = P_CDEMPRESA
                                  AND M.CDINSCESTA    = P_CDINSCESTA
                                  AND M.CDIMPOSTO     = P_CDIMPOSTO
                                  AND M.DTINIPERIODO  >= P_DTINICIAL
                                  AND M.DTFIMPERIODO  <= P_DTFINAL
                                  AND I.NRSEQUMAPAPU  = M.NRSEQUMAPAPU
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                  AND SUBSTR(I.CDFISCOPERNF,1,1) IN ('3','7')
                                  AND I.CDFILIAL      = N.CDFILIAL
                                  AND I.NRLANCTONF    = N.NRLANCTONF
                                  AND N.IDORIGDESTNF  = 'L'
                                  AND DECODE(N.IDENTRSAIDOP,'E',N.CDFILIRECE,N.CDFILIEMIT) = E.CDFILIAL
                                  AND E.IDTPENDEFILI  = 'P'
                                  AND E.CDPAIS        = C_PAIS.CDPAIS
                                GROUP BY C_PAIS.CDPAISGMB) NF
                      GROUP BY NF.CDPAISGMB) LOOP

         V_DADOS_960 := LPAD(C_REG960.CDPAISGMB,3,'0')||
                        LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG960.VRENTRADA),'00000000000000.00'),'0'),'.',''))||
                        LTRIM(REPLACE(NVL(TO_CHAR(TO_NUMBER(C_REG960.VRSAIDA),'00000000000000.00'),'0'),'.',''));

         V_CONT_PAIS := NVL(V_CONT_PAIS,0) + 1;

      END LOOP;

      V_960 := NVL(V_960,'')||NVL(V_DADOS_960,'');
      V_DADOS_960 := NULL;

      IF V_CONT_PAIS = 15 THEN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (RPAD(RTRIM('6'), 10, '0'), RPAD('960'||P_CDINSCESTA||V_960,540,'0'), P_NRSEQARQMAG);
         V_960 := NULL;
         V_CONT_PAIS := 0;
      END IF;
   END LOOP;

   IF V_960 IS NOT NULL THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD(RTRIM('6'), 10, '0'), RPAD('960'||P_CDINSCESTA||V_960,540,'0'), P_NRSEQARQMAG);
   END IF;

   V_990 :=  '990'||
             P_CDINSCESTA||
             RPAD(' ', 490, ' ')||
             RPAD('0', 37, '0');

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD(RTRIM('7'), 10, '0'), V_990, P_NRSEQARQMAG);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_GMB','5.55.xxx'); END;
/

